﻿using System;
using Unit4.CollectionsLib;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class TaxiStation
    {
        private string nameStaiotion;//שם תחנה
        private List<Taxi> listTaxi;//רשימת מוניות
        //constractor
        public TaxiStation(string nameStaiotion)
        {
            this.nameStaiotion = nameStaiotion;
            this.listTaxi = new List<Taxi>();
        }
        //פעולה המוסיפה מונית לתחנה
        public void AddTaxi(string name,int taxiId,int numPass)
        {
            this.listTaxi.Insert(null, new Taxi(taxiId, name, numPass));
        }
        //פעולה מחזירה מספר רשוי של מונית פנויה כלשהי
        public int GetIdAvailable(int num)
        {
            Node<Taxi> pos = this.listTaxi.GetFirst();
            while (pos != null)
            {
                if (pos.GetInfo().GetNumPass() >= num)
                {
                    pos.GetInfo().TaxiBusy();
                    return pos.GetInfo().GetId();
                }
               else pos = pos.GetNext();
            }
            return -1;
        }
        //פעולה המחזירה רשימת שמות הנהגים הפנויים
        public List<string> GetNamesAvailable()
        {
            Node<Taxi> pos = this.listTaxi.GetFirst();
            List<string> list2=new List<string>();
            Node<string> pos2=list2.GetFirst();
            while (pos != null)
            {
                if (pos.GetInfo().IsAvaliable() == true)
                    pos2 = list2.Insert(pos2, pos.GetInfo().GetName());
                pos = pos.GetNext();
            }
            return list2;
        }
        public override string ToString()
        {
            string s = "";
            Node<Taxi> pos = this.listTaxi.GetFirst();
            while (pos != null)
            {
                s = s + pos.GetInfo() + " , ";
                pos = pos.GetNext();
            }
            return s;
        }
    }
}
